'use strict';

var gulp = require('gulp');
var $ = require('gulp-load-plugins')();

var config = {
  srcFolder: 'src',
  distFolder: 'dist',
};

gulp.task('js', [systemjsBuild.name]);
gulp.task(scss.name, scss);
gulp.task(deploy.name, deploy);

////////////////////////////////////////////////////////////////////////////////
// JS
////////////////////////////////////////////////////////////////////////////////
gulp.task(systemjsBuild.name, systemjsBuild);

var SystemjsBuilder = require('systemjs-builder');

function systemjsBuild() {
  var builder = new SystemjsBuilder();

  return builder
    .loadConfig('./jspm.config.js')
    .then(function(){
      builder.config({ baseURL: 'file:' + process.cwd() });
      return Promise.all([builder.trace('angular-touch'), builder.trace('angular'), builder.trace('./index')]);
    })
    .then(function (trees) {
      var app = builder.subtractTrees(
        trees[2], /*trees[0],*/ trees[1]
      );
      return builder.buildTree(app, config.distFolder + '/outfile.js');
      /*return Promise.all([
        builder.buildTree(commonTree, config.distFolder + '/shared-bundle.js')
        builder.buildTree(
          builder.subtractTrees(trees[1], commonTree),
          config.distFolder + '/out.js'
        )
      ]);*/
      //
      //builder.subtractTrees('github:angular/bower-angular-touch@1.3.15/angular-touch', 'github:angular/bower-angular@1.3.15');
      ///return builder.build('./index', config.distFolder + '/outfile.js');
    });
}

function es6() {
  return gulp.src([
    '**/!(*.spec).js',
    // Don't touch my critical js !
    // It will be added injected as it stands in the html
    '!critical.js'
  ], { cwd: config.srcFolder })
    .pipe($.changed(config.outFolder))
    .pipe($.plumber())
    .pipe($.babel({
      experimental: true,
      modules: 'system'
    }))
    .pipe(gulp.dest(config.outFolder));
}
// *

////////////////////////////////////////////////////////////////////////////////
// SCSS
////////////////////////////////////////////////////////////////////////////////
function scss() {
  return $.rubySass(config.srcFolder + '/uiSlider.scss', {
    style: 'expanded',
    lineNumbers: true,
    precision: 3
  })
    .on('error', function (err) {
      console.error('Error!', err.message);
    })
    .pipe($.autoprefixer('last 5 version'))
    .pipe(gulp.dest(config.distFolder));
}
// *

////////////////////////////////////////////////////////////////////////////////
// SCSS
////////////////////////////////////////////////////////////////////////////////
function scss() {
  return $.rubySass(config.srcFolder + '/uiSlider.scss', {
    style: 'expanded',
    lineNumbers: true,
    precision: 3
  })
    .on('error', function (err) {
      console.error('Error!', err.message);
    })
    .pipe($.autoprefixer('last 5 version'))
    .pipe(gulp.dest(config.distFolder));
}
// *

////////////////////////////////////////////////////////////////////////////////
// DEPLOY
////////////////////////////////////////////////////////////////////////////////

var Deployor = require('node-git-deployor');
Deployor.verbose = true;

function deploy() {

  var outWorkspace = Deployor.cloneRepoBranch({
    orphan: true,
    branch: 'dist',
    cloneLocation: '/tmp/ui-slider'
  });

  outWorkspace.extraCleanUp();
  outWorkspace.copy('./dist');
  outWorkspace.commit('Update ' + new Date().toISOString());
  outWorkspace.push();

}
// *
